﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
//using NativeLibraryManager;
using System.Text;
using System.Threading;
using HSDAQNet;
using System.Text.RegularExpressions;

namespace callnetcore
{
    internal class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        public static void Main(string[] args)
        {
            Console.WriteLine("SDK=" + HSDAQNet.Sys.GetSDKVersion());

            string IP = "";
            bool ret = false;
            bool quitIP = false;
            bool quit = false;

            IntPtr hHS;

            UInt16 gVal = 0;
            Int16 oVal = 0;

            UInt16[] gVarr = new UInt16[8];
            Int16[] oVarr = new Int16[8];
            short ChCnt = 8;



            UInt32 totalRecv = 0;
            short Gain = 0;
            uint ulleng = 0;
            ushort BufferStatus = 0;
            UInt32 readsize = 0;

            short TrigMode = 0;
            UInt32 targetCnt = 10000;
            int sampleRate = 35000;

            //unsigned long totalRead=0,totalReceived=0;
            float[] fdataBuffer = new float[targetCnt * 8 * 2];
            short DataTransMethod = 0;
            short AutoRun = 0;
            int t1 =0;

            while (quitIP == false)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quitIP = true;
                    Thread.Sleep(100);
                }
            }


            hHS = HSDAQNet.Sys.HS_Device_Create(IP);

            Console.WriteLine("HSDAQ SDK Ver= " + HSDAQNet.Sys.GetSDKVersion().ToString());
            Console.WriteLine("ET7H16 Firmware Ver= " + HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString());

            ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun);

            HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ref ChCnt, ref Gain, ref TrigMode, ref sampleRate, ref targetCnt, ref DataTransMethod, ref AutoRun);
            Console.WriteLine("Ch=" + ChCnt + ",Gain=" + Gain + ",TrigMode=" + TrigMode + ",sampleRate=" + sampleRate + ",targetCnt=" + targetCnt);

            for (int ch = 0; ch < 8; ch++)
            {
                HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, Gain, ref gVal, ref oVal);

                gVarr[ch] = gVal;
                oVarr[ch] = oVal;
                Console.WriteLine("[ch" + ch + "]Gain = " + gVal + " , Offset = " + oVal);
            }


            if (!ret)
            {
                Console.WriteLine("Error code1 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
            }
            else
            {
                ret = HSDAQNet.HSIO.HS_StartAIScan(hHS);
                if (ret == false)
                {
                    Console.WriteLine("Error code2 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                }
                else
                {
                    Console.WriteLine("Start capturing data by pressing any key other than 'Q', then press 'Q' to stop capturing data");
                    t1 = Environment.TickCount;
                }

                while (quit == false && ret==true)
                {
                    //Console.Clear();
                    //Console.Write("capturing data...");
                    ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, ref BufferStatus, ref ulleng);
                    //UInt32[] dataBuffer = new UInt32[ulleng * 8 * 2];

                    if (ret == false)
                    {
                        Console.WriteLine("Error code3 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                    }
                    else
                    {
                        if (BufferStatus > 2) //AI buffer overflow
                        {

                            //  2:  AD_BUF_OVERFLOW	
                            //  4:  AD_SCAN_STOP
                            //  8:  AD_DATA_SAMPLING_TIMEOUT

                            Console.WriteLine("BufferStatus Error<" + BufferStatus + ">," + ulleng);
                            break;
                        }
                    }
                    if (ulleng == targetCnt)
                    {

                        readsize = HSDAQNet.HSIO.HS_GetAIBuffer(hHS, fdataBuffer, targetCnt);

                        if (readsize == targetCnt)
                        {
                            quit = true;
                        }
                        else
                        {
                            Console.WriteLine("readsize = " + readsize.ToString() + "\r\nGet AI buffer error");
                        }
                        break;
                    }
                }
                HSDAQNet.HSIO.HS_StopAIScan(hHS);
                HSDAQNet.Sys.HS_Device_Release(hHS);
                Console.WriteLine("\r\nAP total read = " + readsize + "\r\n");
            }

            Console.WriteLine("Press 'Q' to quit program");

            while (Console.ReadKey(true).Key != ConsoleKey.Q) ;

        }
    }
}

