﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using HSDAQNet;
using System.Text.RegularExpressions;
namespace ET7H24_Encoder
{
    class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        static void Main(string[] args)
        {
            bool quit = false, ret = false;
            string IP = "";
            IntPtr hHS = IntPtr.Zero;
            int ch = 0, Mode = 0, LPF_Mode = 0, Xor_Mode = 0;
            uint ENC_val = 0;


            Console.WriteLine("!!This demo is about how to use the encoder functions of ET-7H24!!");
            Console.WriteLine("ET-7H24 has 1 encoder channel");
            while (!quit)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quit = true;
                    Thread.Sleep(100);
                }
            }
            quit = false;
            hHS = HSDAQNet.Sys.HS_Device_Create(IP);
            if (hHS == null || hHS == IntPtr.Zero)
            {
                Console.WriteLine("Connect Fail");
                Console.WriteLine("\nPress any key to close...");
                Console.ReadKey();
                return;
            }
            HSDAQNet.IO.HS_ClearEncoder(hHS, ch);
            while (!quit)
            {
                Console.WriteLine("1) Set Mode");
                Console.WriteLine("2) Set Low pass filter");
                Console.WriteLine("3) Set Xor");
                Console.WriteLine("9) Run");
                Console.WriteLine("Q) Quit");
                var change = Console.ReadKey();
                switch (change.Key)
                {
                    case ConsoleKey.NumPad1:
                    case ConsoleKey.D1:
                        Console.WriteLine("\nInput Mode 0 ~ 2");
                        Console.WriteLine("[0] CW/CCW");
                        Console.WriteLine("[1] DIR/PLS");
                        Console.WriteLine("[2] A/B Phase");
                        Mode = int.Parse(Console.ReadLine());
                        break;
                    case ConsoleKey.NumPad2:
                    case ConsoleKey.D2:
                        Console.WriteLine("\nInput LPF Mode 0 ~ 8");
                        Console.WriteLine("[0] Disable");
                        Console.WriteLine("[1] 3.6 MHz");
                        Console.WriteLine("[2] 1.8 MHz");
                        Console.WriteLine("[3] 950 KHz");
                        Console.WriteLine("[4] 480 KHz");
                        Console.WriteLine("[5] 240 KHz");
                        Console.WriteLine("[6] 120 KHz");
                        Console.WriteLine("[7] 60  KHz");
                        Console.WriteLine("[8] 60  KHz");
                        LPF_Mode = int.Parse(Console.ReadLine());
                        break;
                    case ConsoleKey.NumPad3:
                    case ConsoleKey.D3:
                        Console.WriteLine("\nInput Xor Mode 0 ~ 3");
                        Console.WriteLine("[0] A disable , B disable");
                        Console.WriteLine("[1] A enable  , B disable");
                        Console.WriteLine("[2] A disable , B enable");
                        Console.WriteLine("[3] A enable  , B enable");
                        Xor_Mode = int.Parse(Console.ReadLine());
                        break;
                    case ConsoleKey.NumPad9:
                    case ConsoleKey.D9:
                        quit = true;
                        HSDAQNet.IO.HS_SetEncoderMode(hHS, ch, Mode, LPF_Mode, Xor_Mode);
                        break;
                    case ConsoleKey.Q:
                        HSDAQNet.Sys.HS_Device_Release(hHS);
                        return;
                }
            }
            Console.WriteLine("\nPress 'Q' to stop...");
            while (true)
            {
                HSDAQNet.IO.HS_ReadEncoder(hHS, ch, ref ENC_val);
                Console.Write("\rENC value : " + ENC_val);
                Thread.Sleep(500);
                if (Console.KeyAvailable)
                {
                    if (Console.ReadKey(true).Key == ConsoleKey.Q)
                    {
                        HSDAQNet.IO.HS_ClearEncoder(hHS, ch);
                        break;
                    }
                }
            }
            HSDAQNet.Sys.HS_Device_Release(hHS);
            Console.WriteLine("\nPress any key to close...");
            Console.ReadKey();
        }
    }
}
